using System;
using System.Numerics;
class aucsu
{
    static void Main()
    {
        string[] s=Console.ReadLine().Split();
        int n= int.Parse(s[0]);
        int m= int.Parse(s[1]);
        int[,] a=new int[n,m];
        int i,j;
        int z=0;
        for(i=0; i <n; i++)
        {
            string[] sr=Console.ReadLine().Split();
            for(j=0; j <m; j++)
            {
                a[i,j]=int.Parse(sr[j]);
            }
        }
        int q=int.Parse(Console.ReadLine());
        for(int k=0; k<q; k++)
        {
            string[] p=Console.ReadLine().Split();
            int x= int.Parse(p[0]);
            int y= int.Parse(p[1]);
            x--;
            y--;
            i=0;
            j=0;
            z=0;
            while(i<n && j<m)
            {
                if(i==n-1)
                {
                    z+=a[i,j];
                    j++;
                }
                else if(j==m-1)
                {
                    z+=a[i,j];
                    i++;
                }
                else if(((i+1!=x || j!=y) && ((i+2<n && (i+2!=x || j!=y))||(j+1<m && (j+1!=y || i+1!=x)))) && ((i!=x || j+1!=y) && ((j+2<m && (i!=x || j+2!=y))||(i+1<n && (j+1!=y || i+1!=x)))))
                {
                    if(a[i++,j]<a[i,j++])
                    {
                        z+=a[i,j];
                        i++;
                    }
                    else
                    {
                        z+=a[i,j];
                        j++;
                    }
                }
                else if(((i+1!=x || j!=y) && ((i+2<n && (i+2!=x || j!=y))||(j+1<m && (j+1!=y || i+1!=x)))))
                {
                    z+=a[i,j];
                    i++;
                }
                else
                {
                    z+=a[i,j];
                    j++;
                }
            }
            Console.WriteLine(z);
        }
    }
}